Name:           cachefilesd
Version:        0.8
Release:        5%{?dist}
Summary:        CacheFiles userspace management daemon
Group:          System Environment/Daemons
License:        GPL
URL:  			http://people.redhat.com/~dhowells/fscache/
Source0:        http://people.redhat.com/dhowells/fscache/cachefilesd-%{version}.tar.bz2

Patch1: cachefilesd-0.7-verbose.patch
Patch2: cachefilesd-0.8-downgrade.patch
Patch3: cachefilesd-0.8-initscript.patch
Patch4: cachefilesd-0.8-cull-doc.patch
Patch5: cachefilesd-0.8-initscript2.patch

BuildRoot:      %{_tmppath}/%{name}-%{version}-root-%(%{__id_u} -n)
BuildRequires: automake, autoconf
Requires(post): /sbin/chkconfig, /sbin/service
Requires(preun): /sbin/chkconfig, /sbin/service

%description
The cachefilesd daemon manages the caching files and directory that are
that are used by network filesystems such a AFS and NFS to  
do persistent caching to the local disk.

%prep
%setup -q
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1

%build
%ifarch s390 s390x
PIE="-fPIE"
%else
PIE="-fpie"
%endif
export PIE
CFLAGS="`echo $RPM_OPT_FLAGS $ARCH_OPT_FLAGS $PIE`"

make all


%install
rm -rf %{buildroot}
mkdir -p %{buildroot}/sbin
mkdir -p %{buildroot}%{_sysconfdir}/rc.d/init.d
mkdir -p %{buildroot}%{_mandir}/{man5,man8}
mkdir -p %{buildroot}/usr/share/doc/%{name}-%{version}
make DESTDIR=%{buildroot} install

install -m 644 cachefilesd.conf %{buildroot}%{_sysconfdir}
install -m 755 cachefilesd.initd %{buildroot}%{_sysconfdir}/rc.d/init.d/cachefilesd

%clean
rm -rf $RPM_BUILD_ROOT

%post 
/sbin/chkconfig --add %{name}
# Create cache dir
cachedir=`grep ^dir /etc/cachefilesd.conf | awk '{print $2}'`
[ -n "$cachedir" ] && mkdir -p "$cachedir" 

%preun
if [ $1 -eq 0 ]; then
	/sbin/service cachefilesd stop >/dev/null 2>&1
	/sbin/chkconfig --del %{name}
	# Remove cache dir
	cachedir=`grep ^dir /etc/cachefilesd.conf | awk '{print $2}'`
	[ -n "$cachedir" ] && rm -rf "$cachedir" 
fi

%postun
if [ "$1" -ge 1 ]; then
	/sbin/service cachefilesd condrestart >/dev/null 2>&1
fi


%files
%defattr(-,root,root)
%doc README
%doc howto.txt
%config(noreplace) %{_sysconfdir}/cachefilesd.conf
%attr(0755,root,root) %{_sysconfdir}/rc.d/init.d/cachefilesd
/sbin/*
%{_mandir}/*/*

%changelog
* Fri Apr  4 2008 David Howells <dhowells@redhat.com> 0.8-5
- Work around a problem in the status() function in /etc/init.d/functions where
  multiple recursions through an initscript can confuse pidof (bz 237827).
- Make initscript wait for cachefilesd to complete after signalling it to stop
  (bz 237827).

* Thu Mar 27 2008 David Howells <dhowells@redhat.com> 0.8-4
- Documented limitations in current culling algorithm (bz 220060).

* Tue Jan 22 2008 Steve Dickson <steved@redhat.com> 0.8-3
- Reworked initscript to conform to new guidelines (bz 237827)

* Wed Aug 15 2007 Steve Dickson <steved@redhat.com> 0.8-2
- Removed some upstream bits that leaked into the RHEL5 
  version (bz 250424)
- Added the creation/removal of the cache directory when
  the rpm is installed and removed.

* Thu Jul 12 2007 Steve Dickson <steved@redhat.com> 0.8-1
- Use stat64/fstatat64 to avoid EOVERFLOW errors from 
  the kernel on large files (bz 246238).

* Wed Nov  8 2006 Steve Dickson <steved@redhat.com> 0.7-5
- Fixed typo in verbose.patch

* Fri Nov  3 2006 Steve Dickson <steved@redhat.com> 0.7-5
- Added the -v flag  (bz 212831)

* Thu Oct 19 2006 Steve Dickson <steved@redhat.com> 0.7-4
- Fixed typo that was causing the howto.txt not to
  be installed.

* Sun Oct 01 2006 Jesse Keating <jkeating@redhat.com> - 0.7-2
- rebuilt for unwind info generation, broken in gcc-4.1.1-21

* Fri Sep 22 2006 Steve Dickson <steved@redhat.com> 0.7-1
- updated to 0.7 which adds the howto.txt

* Wed Aug 30 2006 Steve Dickson <steved@redhat.com> 0.6-1
- Fixed memory corruption problem
- Added the fcull/fstop/frun options

* Fri Aug 11 2006 Steve Dickson <steved@redhat.com> 0.5-1
- Upgraded to 0.5 which fixed initial scan problem when 
  started on an empty cache (bz 202184)

* Tue Aug  8 2006 Steve Dickson <steved@redhat.com> 0.4-3
- Updated init.d script to look for cachefilesd in /sbin
- Added postun and preun rules so cachefilesd is stopped
  and started when the rpm is updated or removed.

* Tue Aug  7 2006 Jesse Keating <jkeating@redhat.com> 0.4-2
- require /sbin/chkconfig not /usr/bin/chkconfig

* Tue Aug  1 2006 David Howells <dhowells@redhat.com> 0.4-1
- Discard use of autotools

* Tue Aug  1 2006 Steve Dickson <steved@redhat.com> 0.3-3
- Added URL to source file

* Fri Jul 28 2006 Steve Dickson <steved@redhat.com> 0.3-2
- Added post and preun rules
- Changed init.d script to up right before portmapper. 

* Fri Jun  9 2006 Steve Dickson <steved@redhat.com> 0.3-1
- Incorporated David Howells manual page updates

* Thu Jun  8 2006 Steve Dickson <steved@redhat.com> 0.2-1
- Made the daemon 64-bit application.
- Changed the syslog logging to log the daemon's PID
- Changed OS error logging to log errno number as well the string

* Sat Apr 22 2006 Steve Dickson <steved@redhat.com> 0.1-1
- Initial commit

